<!DOCTYPE html>
<html>
    <head>
        <title>Admin Page COOK-R</title>
        <meta charset="utf-8">
        <link rel="stylesheet" href="http://cook-r.com/onewebstatic/css/style.css">
        <style>
            .table, th, td {
              border: 1px solid black;
              border-collapse: collapse;
            }
            th, td {
              padding: 5px;
              text-align: left;    
            }
        </style>
    </head>
    
    <body>
        <h1>Administratif et couts</h1>  
        <?php
        	$servername = 'cook-r.com.mysql';
            $username = 'cook_r_comdolibarr';
            $password = htmlspecialchars($_POST['pass']);
			$database = 'cook_r_comdolibarr';
            
            //On établit la connexion
            $conn = new mysqli($servername, $username, $password, $database);
            
            //On vérifie la connexion
            if($conn->connect_error){
				die('Erreur : ' .$conn->connect_error);
            }
            echo 'Connexion réussie';
            echo "<br>";
            
            $product = htmlspecialchars($_POST['product_ID']);
            echo 'Produit recherché : ';
            echo $product;
            echo "<br>";
            echo "<br>";
            
            //Créé une array multidimentionnelle de tous les compsés trouvés dans Factory
			function getChildren($parent,$conn) {
			$query = "SELECT * FROM llx_product_factory WHERE fk_product_father = $parent";
			$result = mysqli_query($conn, $query);
			//$children = array();
			$i = 0;
	
			while($row = mysqli_fetch_assoc($result)) {
				$children[$i] = array();
				$children[$i]['ID'] = $row['fk_product_children'];
				$children[$i]['qty'] = (float)$row['qty'];
				$children[$i]['pmp'] = number_format($row['pmp'], 2, '.', ' ');
				$children[$i]['children'] = getChildren($row['fk_product_children'],$conn);
			$i++;
			}
			return $children;
			}
			
			//Affiche l'array complète sous forme d'un arbre
			function printList($array = null) {
				if (count($array)) {
					echo "<ul>";

					foreach ($array as $item) {
						echo "<li>";
						echo $item['ID'];
						echo ' , ';
						echo $item['qty'];
					//	echo ' , ';
					//	echo $item['pmp'];
						if (count($item['children'])) {
							printList($item['children']);
						}
						echo "</li>";
					}

					echo "</ul>";

				}

			}
			
			//Affiche l'array d'enfants sous forme de tableau
			function printTab ($array =null){
    			if (count($array)) {
                    echo "<table border: 1px solid black>";
                    echo "<tr>";
                    echo "<th>Name</th>";
                    echo "<th>Quantity</th>";
                    echo "<th>Price (u)</th>";
                    echo "<th>Price (tot)</th>";
                    echo "</tr>";
                    foreach ($array as $item) {
                        // Output a row
                        echo "<tr>";
                        echo "<td>"; 
                        echo $item['ID']; 
                        echo "</td>";
                        echo "<td>"; 
                        echo $item['qty']; 
                        echo "</td>";
                        echo "<td>"; 
                        echo $item['pmp']; 
                        echo "</td>";
                        echo "<td>"; 
                        echo $item['pricetot']; 
                        echo "</td>";
                        echo "</tr>";
                    }
                    echo "</table>";
    			}
			}	
			
			// Permet de répercuter la quantité des parents sur les enfants
			function HeriteQtyFromParent (&$array =null, $quantite) {
			    if (count($array)) {
					foreach ($array as &$item) {
    					$item['qty']  = $item['qty']*$quantite;
    					
    					if (count($item['children'])) {
    						HeriteQtyFromParent ($item['children'],$item['qty']);
						}
					}
			    }
			    return $array;	
			}
			
			// Récupère le nom (llx_product) depuis l'ID (llx_factory)
			function getnamefromID (&$array =null, $conn) {
			    if (count($array)) {
					foreach ($array as &$item) {
					    $ID = $item['ID'];
					    $query = "SELECT * FROM llx_product WHERE rowid = $ID";
			            $result = mysqli_query($conn, $query);
			            $row = mysqli_fetch_assoc($result);
			            $item['ID'] = $row['ref'];
    					if (count($item['children'])) {
    						getnamefromID ($item['children'],$conn);
						}
					}
			    }
			    return $array;	
			}
			
			// Affiche uniquement les enfants (qui ne sont pas parents)
			function printChilds($array = null) {
				if (count($array)) {
					//echo "<ul>";

					foreach ($array as $item) {
						if (count($item['children'])) {
							printChilds($item['children']);
						}
						else {						
						echo "<li>";
						echo $item['ID'], "/", $item['qty'], "/", $item['pmp'];
						}
						echo "</li>";
					}

					echo "</ul>";
				}

			}
			
			//Créé une nouvelle liste composée uniquement des enfants (qui ne sont pas parents)
			function MakeNewListChilds($array = null, &$newarray =null, &$i=0) {
				if (count($array)) {
					foreach ($array as $item) {
						if (count($item['children'])) {
							MakeNewListChilds($item['children'],$newarray,$i);
						}
						else {			
						    $newarray[$i]['ID']=$item['ID'];
						    $newarray[$i]['qty']=$item['qty'];
						    $newarray[$i]['pmp']=$item['pmp'];
						    $newarray[$i]['pricetot']=$item['pmp']*$item['qty'];
						    $i++;
						}
					}
				}
				return $newarray;
			}
			
		function ConsolidateAndSort ($array = null,$total){
		    $i=0;
		    $newarray =array();
			    if (count($array)){
			        foreach ($array as $item) {
			            $trouve=0;
			            if (count($newarray)){
			            foreach ($newarray as &$newitem){
			                if ($item['ID']==$newitem['ID']){
			                    $newitem['qty']=$newitem['qty']+$item['qty'];
			                    $newitem['pricetot']=$newitem['pricetot']+$item['pricetot'];
			                    $trouve=1;
			                }}}
			                if ($trouve==0) {
			                    $newarray[$i]['ID']=$item['ID'];
			                    $newarray[$i]['qty']=$item['qty'];
			                    $newarray[$i]['pmp']=$item['pmp'];
			                    $newarray[$i]['pricetot']=$item['pricetot'];
			                    $i++;
			                }
       
			        }
			    }
			    sort($newarray);
			    if ($total==1){
    			    $totalpmp=0;
    			    $totalqty=0;
    			    foreach ($newarray as &$newitem){
    			        $totalpmp=$totalpmp+$newitem['pricetot'];
    			        $totalqty=$totalqty+$newitem['qty'];
    			    }
    			    $newarray[$i+1]['ID']="Total";
    			    $newarray[$i+1]['qty']=$totalqty;
    			    $newarray[$i+1]['pricetot']=$totalpmp;
			    }
			    return $newarray;
			}
			
			// Traitement et affichage
			
			$finalResult = getChildren($product,$conn);
			$finalResult = getnamefromID ($finalResult,$conn); 
			printList($finalResult);
			
			$finalResult = HeriteQtyFromParent ($finalResult,1);
            $finalResult2 = MakeNewListChilds($finalResult);
            $total=1; // Ligne résultat : 0 = sans 1 = avec
            $finalResultCons = ConsolidateAndSort($finalResult2,$total);
		    printTab($finalResultCons);
	
        ?>
    </body>
</html>